codeforces-604B More Cowbell(贪心)

时间:2021-02-14 21:59:57


Kevin Sun wants to move his precious collection of n cowbells from Naperthrill to Exeter, where there is actually grass instead of corn. Before moving, he must pack his cowbells into k boxes of a fixed size. In order to keep his collection safe during transportation, he won't place more than two cowbells into a single box. Since Kevin wishes to minimize expenses, he is curious about the smallest size box he can use to pack his entire collection.

Kevin is a meticulous cowbell collector and knows that the size of his i-th (1 ≤ i ≤ n) cowbell is an integer si. In fact, he keeps his cowbells sorted by size, so si - 1 ≤ si for any i > 1. Also an expert packer, Kevin can fit one or two cowbells into a box of size s if and only if the sum of their sizes does not exceed s. Given this information, help Kevin determine the smallest s for which it is possible to put all of his cowbells into k boxes of size s.

Input

The first line of the input contains two space-separated integers n and k (1 ≤ n ≤ 2·k ≤ 100 000), denoting the number of cowbells and the number of boxes, respectively.

The next line contains n space-separated integers s1, s2, ..., sn (1 ≤ s1 ≤ s2 ≤ ... ≤ sn ≤ 1 000 000), the sizes of Kevin's cowbells. It is guaranteed that the sizes si are given in non-decreasing order.

Output

Print a single integer, the smallest s for which it is possible for Kevin to put all of his cowbells into k boxes of size s.

Input

2 1
2 5
Output
7
Input
4 3
2 3 5 9
Output
9
Input
3 2
3 5 7
Output
8
一开始想用二分法去做,没有做成.
思路就是
case1: 若箱子数>=铃铛数 则max=a[n-1];
case2:若箱子数<铃铛数 则先从最大的铃铛开始放直到放满箱子,之后把剩下的铃铛中质量最大的依次放到质量小的的箱子中;
      然后对箱子质量从大到小排序,则max=a[0];
 
  
#include<stdio.h>
#include<algorithm>
using namespace std;
long long a[1000005],b[1000005];
long long n,k,i;
int main()
{

    scanf("%d%d",&n,&k);
    for (i=0;i<n;i++)
    {
        scanf("%I64d",&a[i]);
    }
    if (k>=n) printf("%I64d",a[n-1]);
    else
    {
      for (i=0;i<k;i++)
      {
          b[i]=a[n-1-i];
      }
      for (i=0;i<n-k;i++)
      {
          b[k-i-1]=b[k-i-1]+a[n-k-i-1];
      }
      sort(b,b+k);
      printf("%I64d",b[k-1]);
    }
}